Bug 1014544 - Review Request: almohawell - Linux Packages Installer and Convertor
Review Request: almohawell - Linux Packages Installer and Convertor
Status: NEW
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
unspecified Severity medium
: ---
: ---
Assigned To: Nobody's working on this, feel free to take it
Fedora Extras Quality Assurance
:
Depends On: 1242630
Blocks:
  Show dependency treegraph
 
Reported: 2013-10-02 06:28 EDT by Mosaab Alzoubi
Modified: 2015-12-06 13:25 EST (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description Mosaab Alzoubi 2013-10-02 06:28:32 EDT
Spec URL: http://helallinux.com/paste/show.php?id=1220
SRPM URL: http://ftp5.gwdg.de/pub/opensuse/repositories/home:/Kenzy:/packages/Fedora_19/src/almohawell-9.3-1.1.src.rpm
Description: Almohawell is a fork of alien program , and it's a developed copy of
Almasa alien which written to convert between packages.
Almohawell has many features which not found on alien and Almasa alien
Almohawell support many types of packages like rpm , tgz , deb .. for
convert and install.
Fedora Account System Username: moceap
Comment 1 Mosaab Alzoubi 2013-10-06 07:21:23 EDT
Spec URL: http://helallinux.com/paste/show.php?id=1220&mode=raw
SRPM URL: http://ftp5.gwdg.de/pub/opensuse/repositories/home:/Kenzy:/packages/Fedora_19/src/almohawell-9.3-1.1.src.rpm
Description: Almohawell is a fork of alien program , and it's a developed copy of
Almasa alien which written to convert between packages.
Almohawell has many features which not found on alien and Almasa alien
Almohawell support many types of packages like rpm , tgz , deb .. for
convert and install.
Fedora Account System Username: moceap
Comment 2 Ralf Corsepius 2013-10-06 12:09:24 EDT
Some remarks: There are quite a few issues with this submission:

1. You (Mosaab Alzoubi) are pointing to a package in SUSE's OBS, which appears to have been authored by somebody named "Muhammad Shaban".
Could you elaborate this situation?

2. The spec files needs further work to comply with the Fedora Packaging Guidelines. Please make yourself familiar with the Fedora Packaging Guidelines.

Just to mention some issues:

- Source:  %{name}-%{version}.tar.bz2
Source/Source0 should be an URL pointing to an upstream hosting the tarball.

- URL-Tag is missing
Where can upstream be found?

- Requires:  perl cpio rpm dpkg debhelper gcc rpm-build
Please check this. These Requires: seem questionable to me. 
E.g. I cannot spot any reference to gcc inside of this package.

- 
Obsoletes: alien alien-almasa
Provides:  alien alien-almasa

IIRC, alien-almasa has never been part of Fedora
=> there isn't any reason to Obsolete/Provide: alien-almasa in Fedora.

AFAIS, this package does not conflict with alien and can coexist with alien.
=> there isn't any reason to Obsolete/Provide: alien

- In Fedora, %description is supposed to be in English. Mixing other languages and/or scripts into %description is not allowed.
If you want to keep/add an Arabic description, move the Arab description into a separate "%description -l ar" section.

[N.B.: Chances to getting this package into Fedora a bigger, if you entirel remove the Arab section, because most Fedora packagers don't understand/read Arab and therefore will not be able to check this package for "legibility" and will not be able to approve this package.

c.f. https://fedoraproject.org/wiki/Packaging:Guidelines?rd=Packaging/Guidelines#Spec_Legibility.]

- I understand, this spec file's author isn't a native English speaker and likely has limited knowledge of the English language, however this package's %description is phrased in a way, I feel, it should be reworked.
Comment 3 Mosaab Alzoubi 2013-10-06 14:41:00 EDT
OK , Welcome for revision .

Alien program which is package convertor missing many necessary features , so Almasa Alien first built.
Almasa Alien is alien with some changes that allow to control of generated-packages depends, and I sent
the changes to Alien maintainer Joey Hess, but I didn't have answers, So I forked alien completely in
new program Almohawell .

Almohawell has many new required features such as working in multi version of perl in one package , also
Almohawell makes many features as editing requires,license,group,maintainer in generated package . 

Generated RPMS by alien don't compatible with new version of Fedora (and similar) so Almohawell fixing this
bug, RPMS generated by Almohawell have ability to install in Fedora.

I port Almohawell to Fedora to make a way for porting Almohazzem packaging SDK to Fedora repos.

I and Muhammad Shaban working together in smae team, we are seniors of Linux Arab Community http://linuxac.org
So he write RPM package of Almohawell.

------------

For Almohawell spec , I'll try to rewrite it with your marks.

I wrote the describtion of Almohawell in Arabic because it's distributed in Arbic world :)


Thank you.
Comment 4 Christopher Meng 2013-10-07 05:21:28 EDT
Hint:

If you think providing arabic description is helpful for arabic world people(I think I'm right), then put them like this:

-----------

%description
hello world

%description -l ar
مرحبا يا عالم ;)

ar is scratched from ISO 639-X.
Comment 5 Ralf Corsepius 2013-10-07 08:14:45 EDT
(In reply to Christopher Meng from comment #4)
> If you think providing arabic description is helpful for arabic world
> people(I think I'm right), then put them like this:
Christopher are you actually reading what other people write? 
I guess no  (cf. comment#2)
Comment 6 Christopher Meng 2013-10-07 08:45:12 EDT
Yes, I've seen that. But it seems I forgot to paste another part of my comment:

-------------

And do not write something like thanks/credits and license information in all %description(we all know all softwares are open sourced in the repo).

-------------

Besides I tell him how to write actually, he may understand it now.

And I don't think it's a big problem unless you disagree, would you like to waste another new comment?
Comment 7 Mosaab Alzoubi 2013-10-07 13:29:38 EDT
OK , I taked all your notes , and now testing by koji.
Thank you.
Comment 8 Mosaab Alzoubi 2013-10-07 13:32:42 EDT
Spec : http://helallinux.com/paste/show.php?id=1239&mode=raw
SRPM : http://downloads.sourceforge.net/project/oji/srpms/almohawell-9.3.1-1.src.rpm

Description : 
Almohawell is a fork of alien program , and it's a developed copy of
Almasa alien which written to convert between packages.
Almohawell has many features which not found on alien and Almasa alien
Almohawell support many types of packages like rpm , tgz , deb .. for
convert and install.
Comment 9 Mosaab Alzoubi 2013-10-07 14:29:18 EDT
Fixing release line. ( Is this important ? )

Spec : http://helallinux.com/paste/show.php?id=1240&mode=raw
SRPM : http://downloads.sourceforge.net/project/oji/srpms/almohawell-9.3.1-2.fc19.src.rpm

Description : 
Almohawell is a fork of alien program , and it's a developed copy of
Almasa alien which written to convert between packages.
Almohawell has many features which not found on alien and Almasa alien
Almohawell support many types of packages like rpm , tgz , deb .. for
convert and install.
Comment 10 Mosaab Alzoubi 2013-10-07 17:27:24 EDT
There is an error in sourceforge web interface , you can get it through mirrors :

http://ftp.jaist.ac.jp/pub/sourceforge/o/oj/oji/srpms/almohawell-9.3.1-2.fc19.src.rpm
Comment 11 Mosaab Alzoubi 2013-10-08 15:18:16 EDT
Now it hosted on Ojuba server :

Spec : http://ojuba.org/oji/SPECS/almohawell-9.3.1-3.spec
SRPM : http://ojuba.org/oji/SRPMS/almohawell-9.3.1-3.oji.fc19.src.rpm
Comment 12 Ralf Corsepius 2013-10-08 17:47:37 EDT
I think this package violates the GPL.

It's clearly a derivative works of alien and therefore must be licensed GPL'ed only.
Comment 13 Mosaab Alzoubi 2013-10-09 02:15:47 EDT
Almohawell in Waqf license , Alien in Almohawell still in GPL , so whole program as mixed in Waqf (WPL) .

Fedora doing this, it  contain many programs every program has a license and Fedora as mixed has its license.

>>
Comment 14 Ralf Corsepius 2013-10-09 02:53:28 EDT
(In reply to Mosaab Alzoubi from comment #13)
> Almohawell in Waqf license , Alien in Almohawell still in GPL , so whole
> program as mixed in Waqf (WPL) .
Wrong. The GPL does not allow any addtional license restrictions to be applied to a GPL'ed package.

If mixing non-GPL'ed sources into GPL-derived packages, all these non-GPL'ed sources must be GPL-compatible, which in sum renders the whole package GPL'ed ("GPL as umbrella". Individual files under different licenses, the package as a whole under the GPL)

As the Waqf is not an OSI-approved nor FSF-approved license, with many people having doubts on the Waqf not being GPL-compatible, I consider this package to violate copyright laws.

> Fedora doing this, it  contain many programs every program has a license and
> Fedora as mixed has its license.
Cf. above. GPL as umbrella.

Blocking FE-LEGAL

[1] http://lists.debian.org/debian-devel/2010/07/msg00019.html
Comment 15 Mosaab Alzoubi 2013-10-09 03:05:10 EDT
Then , is that mean to republish Almohawell under GPL2 only ??
Comment 16 Ralf Corsepius 2013-10-09 03:24:22 EDT
(In reply to Mosaab Alzoubi from comment #15)
> Then , is that mean to republish Almohawell under GPL2 only ??

Yes, IMO, upstream releasing Almohawell under GPL2 or GPLv2+ 
* with all references to WAQF removed 
or 
* with WAQF having been approved by the OSI of the FSF
would be perfectly OK (But IANAL).
Comment 17 Mosaab Alzoubi 2013-10-09 04:23:29 EDT
Well ,

Prophet Muhammad PBUH says : من كتم علما ألجمه الله يوم القيامة بلجام من نار
Which mean : Whoever conceals knowledge, Allah will bridle him with a bridle of fire

So all science in Islam must be public and free. That is fully agree with opensource Philosophy and Methodology .. (GPL in)

Waqf takes this Islamic rule as main target of its using .

Also Waqf is common in Arab opensource community .

I'll try to contact with OSI of FSF .
Comment 18 Ralf Corsepius 2013-10-09 04:47:02 EDT
(In reply to Mosaab Alzoubi from comment #17)

> So all science in Islam must be public and free. That is fully agree with
> opensource Philosophy and Methodology .. (GPL in)
IMO, that's pretty much irrelevant, here, because the GPL doesn't allow any  additions to it - Let's wait what RH's lawyers say.

> I'll try to contact with OSI of FSF .
OK. FYI: I've emailed Joey Hess (original author of Alien).
Comment 19 Ralf Corsepius 2013-10-13 05:23:10 EDT
(In reply to Ralf Corsepius from comment #18)
> OK. FYI: I've emailed Joey Hess (original author of Alien).
Joey Hess has replied.

He has authorized me to forward this:

<joeyhess@kitenet@net>
This is the first that I've heard of this fork

almohawell clearly contains code from alien. It still has my name on it
as the author. Most of the changes are branding changes.

Alien is licensed under version 2 or higher of the GPL, and I have never
given permission for it to be used under any other license.
</joeyhess@kitenet@net>
Comment 20 Mosaab Alzoubi 2013-10-13 06:44:55 EDT
I can't (under GPL or Waqf) remove Joey name from any fork.

Almohawell contain many things Alien don't :
1- Generated RPM by Alien couldn't install under Fedora , Almohawell ones do.
2- Edit maintainer of the generating package.
3- Edit requires of the generating package.
4- Edit license of the generating package.
5- Edit group of the generating package.

I talked to Waqf maintainer : He said : (30 days at least of discuss to approve Waqf at OSI)

Tell that I'll release Almohawell under GPL.



I sent This message and didn't have any reply :
----------------
From: moceap@hotmail.com
To: joeyh@debian.org
Subject: Patches for alien
Date: Fri, 21 Dec 2012 18:09:47 +0200

Hellow Joey , maintainer of alien application .

I was used alien many times , but it has abig problem
that I can't add depends manually .

So Almasa-alien has been written , which contain alien
with some changes . These changes allow to add depends
to generated packages by alien .

Almasa alien sourse contain patches  :
http://download.opensuse.org/repositories/home:/Kenzy:/packages/Fedora_17/src/almasa-alien-8.88-5.1.src.rpm
Main discuss :
http://www.linuxac.org/forum/threads/61834
----------------
Comment 21 Mosaab Alzoubi 2013-10-17 10:18:20 EDT
OK new release under GPL only:

Spec : http://ojuba.org/oji/SPECS/almohawell.spec
SRPM : http://ojuba.org/oji/SRPMS/almohawell-9.3.2-1.oji.fc19.src.rpm
Comment 22 Zbigniew Jędrzejewski-Szmek 2013-10-17 15:22:33 EDT
What does the second paragraph in the Arabic translation say?

Why did you bump the license from GPLv2+ to GPLv3+?

Removing FE-LEGAL because the license changed.
Comment 23 Mosaab Alzoubi 2013-10-17 19:00:28 EDT
Arabic text :

"برنامج المحول هو تفريعة من برنامج الاين ، كما أنه هو نسخة مطورة من برنامج ألماسه
ألاين المخصص للتحويل بين الحزم ،
ويتميز برنامج المحول بالعديد من الخصائص والمزايا الجديدة والتي لا تتوفر في أسلافه
ويدعم المحول تحويل وتثبيت العديد من الحزم منها الردهاتية والسلاكويرية و الديبيانية

يأمل مشروع ألماسه أن يكون قد وفقه الله في إضافة برنامج مميز يؤدي المهمة ، ويلخص
على المطورين مسألة إنتاج حزم احترافية لبرامجهم لتوزيعات متعددة بضغطة زر واحدة .
"

Means :

"Almohawell program is a fork of Alien program, also it is a developed version of Almasa Alien customized to converting between packages.
Almohawell has many new features that not found on past convertors, Almohawell could install and convert RPM,TGZ and DEB.

Allah asked by almasa project to make this program perfect in use and easy in generating professional packages in just a touch"

---------------------

I'll fix somethings soon.
Comment 24 Mosaab Alzoubi 2013-10-17 19:31:19 EDT
- To zero warnings by rpmlint.
- Fix legal line.

-------------------------

Spec : http://ojuba.org/oji/SPECS/almohawell.spec
SRPM : http://ojuba.org/oji/SRPMS/almohawell-9.3.2-2.oji.fc19.src.rpm
Comment 25 Mosaab Alzoubi 2015-07-10 22:34:30 EDT
After +2 years exp.. Rebuilt:

Spec : http://ojuba.org/test/almohawell.spec
SRPM : http://ojuba.org/test/almohawell-9.3.2-3.oj35.src.rpm

- Separate requires
- Add #Nothing to build note
- Fix lib dir x86_64 detecting
- Add %%license
- New source in Github
- Update %%description
- Update Summary
Comment 26 Dmitrij S. Kryzhevich 2015-07-13 05:50:40 EDT
1. Perl modules should go to %{perl_vendorlib}. See [1].
2. There is no %license macros, only License tag. LICENSE and gpl-2.0.txt files are to go in %doc.
3a. LICENSE file has wrong permissions: 775. Should be 644.
3b. almohawell file has wrong permissions: 775. Should be 755.
3c. pm files have wrong permissions: 775. Should be 644.
4. Package must have proper perl requirement. See [1].
5. In header, spaces and tabs are mixed. Please choose one of them.
6. In Description please add spaces after commas: "... Rpm, Deb, Tgz ...".

[1] https://fedoraproject.org/wiki/Packaging:Perl?rd=Packaging/Perl
Comment 27 Dmitrij S. Kryzhevich 2015-07-13 05:56:41 EDT
7. (optional) It would be great if you add man file(s).
Comment 28 Dmitrij S. Kryzhevich 2015-07-13 06:34:05 EDT
Looks like my packaging knowledges are to be refreshed.

Consider (2) is dropped. Sorry for the noise.
Comment 29 Mosaab Alzoubi 2015-07-13 15:46:02 EDT
1. This is not common Perl modules .. This just for Almohawell modules and no need to be in common.
2. FOUND
3. FIXED
4. What requires I miss ??
5. FIXED
6. FIXED
7. ADDED


Spec : http://ojuba.org/test/almohawell.spec
SRPM : http://ojuba.org/test/almohawell-9.3.2-4.oj35.src.rpm
Comment 30 Dmitrij S. Kryzhevich 2015-07-14 02:43:55 EDT
> This just for Almohawell modules and no need to be in common.

I'm not insisting here as there are really not shared.

> What requires I miss ??
From the link above:

All perl modules must include the versioned MODULE_COMPAT Requires:
Requires:  perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))

Almohawell is not a module in strict meaning, I agree. So if you think it is not you case - indicate this explicitly here.

> 7. ADDED
Thanks!
Comment 31 Dmitrij S. Kryzhevich 2015-07-14 02:58:45 EDT
Ok. Let me look deeper. Differences from alien are:

--requires
--license
--group
--maintainer
--requires
-w, --without

Did you try to ask Joey Hess to enable this options in original alien?
Comment 32 Ralf Corsepius 2015-07-14 03:13:06 EDT
The provides are dead wrong:

# rpm -q --provides -p /var/lib/mock/fedora-rawhide-i386/result/almohawell-9.3.2-4.fc23.noarch.rpm 
almohawell = 9.3.2-4.fc23
perl(Almohawell::Package)
perl(Almohawell::Package::Deb)
perl(Almohawell::Package::Lsb)
perl(Almohawell::Package::Pkg)
perl(Almohawell::Package::Rpm)
perl(Almohawell::Package::Slp)
perl(Almohawell::Package::Tgz)

perl(...) would correspond to these modules being installed to %{perl_vendorlib}, which they aren't.

=> These provides MUST be filtered out, unless they are installed to %{perl_vendorlib}

@Mosaab: Feel very strongly encouraged to install them to %{perl_vendorlib}.
You are not doing yourself or Fedora a favor and shooting yourselfs into the foot by installing them elsewhere.
Comment 33 Upstream Release Monitoring 2015-12-06 13:25:57 EST
pbrobinson's scratch build of linux-user-chroot?#b7afe5173cbd31b029b027b6f8a14baa5e6ce87a for epel7-archbootstrap and git://pkgs.fedoraproject.org/linux-user-chroot?#b7afe5173cbd31b029b027b6f8a14baa5e6ce87a failed http://koji.fedoraproject.org/koji/taskinfo?taskID=12089939

Note You need to log in before you can comment on or make changes to this bug.